#include "armachine.h"

/**
  * @brief MOV ɾ 
  * @param inst ɾ ü
  */
void ARMachine::_executeMov(ARMinstruction inst)
{
	if( _conditionPassed(inst.cond) ) {
		// RD = RM
		r[inst.rd_num] = r[inst.rm_num];
		if(inst.sbit == 1 && inst.rd_num == 15) {
			if(_currentModeHasSPSR()) {
				SPSR = CPSR;
			} // if currentModeHasSPSR
			else
				throw MimicException("UNPREDICTABLE", "this mode cannot have SPSR");
		} // if S == 1, RD == 15
		else if(inst.sbit == 1) {
			// Nflag = Rd[31];
			setNflag( GetOneBit(r[inst.rd_num], 31) );
			// Z Flag = if Rd == 0 then 1 else 0
			setZflag( (r[inst.rd_num] == 0) ? 1 : 0 );
			// C Flag = shifter_carry_out
			/// @todo shifter_carry_out ΰ
			// V Flag = unaffected
		} // else if S == 1
	} // if conditionPassed
	else {
		printf("%s:  \n", __func__);
		printf("%d, %d\n", CPSR >> 28 & 0xF, inst.cond);
	} // else (if conditionPassed)
}
